import numpy as np
import cv2
import random

video = cv2.VideoCapture('../record.avi')
fps = video.get(cv2.CAP_PROP_FPS)
hasFrame, frame = video.read()

out = cv2.VideoWriter()
out.open('../record2.avi',cv2.VideoWriter_fourcc('M','J','P','G'),fps,(frame.shape[1],frame.shape[0]))

angle = 0
sig = 1
while True:

    if random.uniform(0.0,1.0) < 0.025*abs(angle):
        sig = -angle/abs(angle)
        
    angle += sig*0.25
    warp_matrix = cv2.getRotationMatrix2D((frame.shape[1]/2,frame.shape[0]/2),angle,1)
    rotated = cv2.warpAffine(frame,warp_matrix,(frame.shape[1],frame.shape[0]))

    cv2.imshow('video',rotated)
    if cv2.waitKey(1) == 27:
        break
        
    out.write(rotated)
    
    hasFrame, frame = video.read()
    if not hasFrame:
        break

out.release()
cv2.destroyAllWindows()
