import numpy as np

def getTranslationX(affineTransform):
    return affineTransform[0,2]

def getTranslationY(affineTransform):
    return affineTransform[1,2]

def getScaleX(affineTransform):
    return np.linalg.norm([affineTransform[0,0],affineTransform[1,0]])

def getScaleY(affineTransform):
    return np.linalg.norm([affineTransform[0,1],affineTransform[1,1]])

def getRotation(affineTransform):
    sx = getScaleX(affineTransform)
    sy = getScaleY(affineTransform)
    if sx < 0.0001 or sy < 0.0001:
        return 0
    return np.arctan2(affineTransform[0,1]/sy, affineTransform[0,0]/sx)

def getAffineTransform(scaleX,scaleY,rotation,translationX,translationY):
    warp_matrix = np.zeros((2,3), np.float32)
    warp_matrix[0,0] = np.cos(rotation) * scaleX
    warp_matrix[0,1] = -np.sin(rotation) * scaleY
    warp_matrix[1,0] = np.sin(rotation) * scaleX
    warp_matrix[1,1] = np.cos(rotation) * scaleY
    warp_matrix[0,2] = translationX
    warp_matrix[1,2] = translationY
    return warp_matrix

def combineAffineTransforms(a,b):
    A = np.append(a, [[0, 0, 1]], axis=0)
    B = np.append(b, [[0, 0, 1]], axis=0)
    C = B @ A
    c = np.delete(C, 2, axis=0)
    return c
