#include <opencv2/opencv.hpp>

int main()
{
  // get images from left and right camera
  cv::Mat left_image = cv::imread("../tsukuba_L.png", cv::IMREAD_COLOR);
  cv::Mat right_image = cv::imread("../tsukuba_R.png", cv::IMREAD_COLOR);

  // turn color images to greyscale images
  cv::cvtColor(left_image, left_image, cv::COLOR_BGR2GRAY);
  cv::cvtColor(right_image, right_image, cv::COLOR_BGR2GRAY);

  // calculate depth map
  // cv::Ptr<cv::StereoBM> stereo = cv::createStereoBM(16, 15); // OpenCV3
  cv::Ptr<cv::StereoBM> stereo = cv::StereoBM::create(16, 15); // OpenCV4
  cv::Mat disparity;
  stereo->compute(left_image, right_image, disparity);

  // show the result
  cv::Mat normalized_disparity;
  cv::normalize(disparity, normalized_disparity, 0, 255, cv::NORM_MINMAX, CV_8U);
  cv::imshow("disparity", normalized_disparity);
  cv::waitKey(0);
  cv::destroyAllWindows();
  cv::imwrite("disparity.png", normalized_disparity);
  return 0;
}

